//////////////////////////////////////////////////////////

// FreeRtos Blinky
// lsst auf dem stm32Discovery(stm32F100RB) die blaue LED blinken

//////////////////////////////////////////////////////////

/* Kernel includes. */
#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"
#include "timers.h"

/* STM32 Library includes. */
#include "stm32f10x.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"

void TestTask( void *pvParameters );

void gpio_initialisierung(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Pin   = GPIO_Pin_8;
	GPIO_Init(GPIOC, &GPIO_InitStructure);
}

int main(void)
{

	gpio_initialisierung();

	xTaskCreate( TestTask, ( signed char * ) "Test", configMINIMAL_STACK_SIZE, NULL, 1, NULL );
	vTaskStartScheduler();

	/* If all is well, the scheduler will now be running, and the following line
	will never be reached.  If the following line does execute, then there was
	insufficient FreeRTOS heap memory available for the idle and/or timer tasks
	to be created.  See the memory management section on the FreeRTOS web site
	for more details. */
	for( ;; );
}
/*-----------------------------------------------------------*/

void TestTask( void *pvParameters )
{
	for( ;; )
	{
		GPIOC->ODR |= GPIO_Pin_8; 				  // LED einschalten
		vTaskDelay(100/portTICK_RATE_MS);		  // Task fr 100ms in den Blocked State versetzen
		GPIOC->ODR &= ~GPIO_Pin_8;				  // LED auschalten
		vTaskDelay(1000/portTICK_RATE_MS);		  // Task fr 1000ms in den Blocked State versetzen
	}
}

